## additional test cases
## these are run for avoidance of errors only
## no testoutput is created
require(DoE.MIParray)

if (require(gurobi)){
aus <- gurobi_MIParray(50, c(2,2,2,5,5), 2)
## next command must throw an error
if (require(Rmosek)){
  if (packageVersion("Rmosek") >= "8.0.69" && Rmosek::mosek_version()>="8.1.0.23"){
    try(mosek_MIPcontinue(aus))
    aus3improvem <- mosek_MIPcontinue(aus, improve=FALSE, maxtime=12)  ## fast with mosek
    aus4improvem <- mosek_MIPcontinue(aus3improvem, improve=FALSE, maxtime=12) ## longer time doesn't help either
  }
}
}

if (require(gurobi) && require(Rmosek)){
  if (packageVersion("Rmosek") >= "8.0.69" && Rmosek::mosek_version()>="8.1.0.23"){
    aus <- gurobi_MIParray(50, c(2,2,2,5,5), 2, find.only=TRUE)
    aus <- mosek_MIPcontinue(aus, maxtime=12)
    aus3improveg <- gurobi_MIPcontinue(aus, improve=FALSE, maxtime=20)  ## will not succeed to 576
    aus4improvem <- mosek_MIPcontinue(aus3improveg, improve=FALSE, maxtime=20)
  }
  }


## use case for which the initial array is optimal, although find.only
##   has not been specified; treated internally by setting find.only to TRUE
if (require(Rmosek))
  if (packageVersion("Rmosek") >= "8.0.69" && Rmosek::mosek_version()>="8.1.0.23")
    ausm <- mosek_MIParray(1008, c(42, 12, 6))
if (require(gurobi))
    ausg <- gurobi_MIParray(1008, c(42, 12, 6))

if (require(gurobi) && require(Rmosek)){
  if (packageVersion("Rmosek") >= "8.0.69" && Rmosek::mosek_version()>="8.1.0.23"){
    ## improve=FALSE must yield an error
    ## improve=TRUE does not make sense
    try(mosek_MIPcontinue(ausm))
    try(mosek_MIPcontinue(ausg))
    try(gurobi_MIPcontinue(ausm))
    try(gurobi_MIPcontinue(ausg))
  }
}

## designs found with find.only=TRUE
## make sure to leave them in the state they would be in after 
## an actual optimization attempt of A_R (even if they are proven optimal)
if (require(Rmosek))
  if (packageVersion("Rmosek") >= "8.0.69" && Rmosek::mosek_version()>="8.1.0.23"){
    ausm <- mosek_MIParray(168, c(42,12,6), 2, find.only = TRUE)  ## very fast
    ausmimproved <- mosek_MIPcontinue(ausm, maxtime=10)  ## will not improve
  }
if (require(gurobi)){
  ausg <- gurobi_MIParray(168, c(42,12,6), 2, find.only = TRUE)  ## very fast
  ausgimproved <- gurobi_MIPcontinue(ausg, improve=FALSE, maxtime=10) ## will not improve
}
